// Attach image uploader to the input field
jQuery(document).ready(function($){
 
    // Instantiate the variable that holds the media library frame
    var meta_image_frame;
 
    // Run when the image button is clicked.
    $('#nest-image-upload-button').click(function(e){
 
        // Prevent the default action from occuring
        e.preventDefault();
 
        // If the frame already exists, re-open it
        if ( meta_image_frame ) {
            meta_image_frame.open();
            return;
        }
 
        // Set up the media library frame
        meta_image_frame = wp.media.frames.meta_image_frame = wp.media({
            title: meta_image.title,
            button: { text:  meta_image.button },
            library: { type: 'image' }
        });
 
        // Run when an image is selected
        meta_image_frame.on('select', function(){
 
            // Grab the attachment selection and creates a JSON representation of the model
            var media_attachment = meta_image_frame.state().get('selection').first().toJSON();
 
            // Send the attachment URL to our custom image input field
            $('#nest-image-upload').val(media_attachment.url);
        });
 
        // Open the media library frame
        meta_image_frame.open();
    });
});